Package net.sf.saxon.event

## Class Outputter

- java.lang.Object
- - net.sf.saxon.event.Outputter

- All Implemented Interfaces:
    `javax.xml.transform.Result`, `Receiver`
  Direct Known Subclasses:
    `ComplexContentOutputter`, `EventMonitor`, `OutputterEventBuffer`, `ProxyOutputter`, `SinkOutputter`

      public abstract class Outputter
      extends java.lang.Object
      implements Receiver

  Outputter: This interface represents a recipient of XML tree-walking (push) events. It was originally based on SAX2's ContentHandler, but adapted to handle additional events. Namespaces and Attributes are handled by separate events following the startElement event. Schema types can be defined for elements and attributes.

  The Outputter interface is an important internal interface within Saxon, and provides a powerful mechanism for integrating Saxon with other applications. It has been designed with extensibility and stability in mind. However, it should be considered as an interface designed primarily for internal use, and not as a completely stable part of the public Saxon API.

  Since:
    10.0; derived from the original Outputter interface and SequenceReceiver class. This interface is now used primarily for capturing the results of push-mode evaluation of tree construction expressions in XSLT and XQuery.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected PipelineConfiguration` | `pipelineConfiguration` |
    `protected java.lang.String` | `systemId` |

    - ### Fields inherited from interface javax.xml.transform.Result

      `PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Outputter()` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `append​(Item item)` | Append an arbitrary item (node, atomic value, or function) to the output.
    `void` | `append​(Item item, Location locationId, int properties)` | Append an arbitrary item (node, atomic value, or function) to the output.
    `abstract void` | `attribute​(NodeName attName, SimpleType typeCode, java.lang.CharSequence value, Location location, int properties)` | Notify an attribute.
    `abstract void` | `characters​(java.lang.CharSequence chars, Location location, int properties)` | Notify character data.
    `void` | `close()` | Notify the end of the event stream
    `abstract void` | `comment​(java.lang.CharSequence content, Location location, int properties)` | Notify a comment.
    `abstract void` | `endDocument()` | Notify the end of a document node
    `abstract void` | `endElement()` | Notify the end of an element.
    `Configuration` | `getConfiguration()` | Get the Saxon Configuration
    `PipelineConfiguration` | `getPipelineConfiguration()` | Get the pipeline configuration
    `CharSequenceConsumer` | `getStringReceiver​(boolean asTextNode, Location loc)` | Get a string-value consumer object that allows an item of type xs:string to be appended one fragment at a time.
    `java.lang.String` | `getSystemId()` | Get the system ID
    `abstract void` | `namespace​(java.lang.String prefix, java.lang.String namespaceUri, int properties)` | Notify a namespace binding.
    `void` | `namespaces​(NamespaceBindingSet bindings, int properties)` | Output a set of namespace bindings.
    `void` | `open()` | Notify the start of the event stream
    `abstract void` | `processingInstruction​(java.lang.String name, java.lang.CharSequence data, Location location, int properties)` | Output a processing instruction
    `void` | `setPipelineConfiguration​(PipelineConfiguration pipe)` | Set the pipeline configuration
    `void` | `setSystemId​(java.lang.String systemId)` | Set the System ID of the tree represented by this event stream
    `void` | `setUnparsedEntity​(java.lang.String name, java.lang.String systemID, java.lang.String publicID)` | Notify an unparsed entity URI.
    `void` | `startContent()` | Notify the start of the content, that is, the completion of all attributes and namespaces.
    `abstract void` | `startDocument​(int properties)` | Notify the start of a document node
    `void` | `startElement​(NodeName elemName, SchemaType type, AttributeMap attributes, NamespaceMap namespaces, Location location, int properties)` | Notify the start of an element, supplying all attributes and namespaces
    `abstract void` | `startElement​(NodeName elemName, SchemaType typeCode, Location location, int properties)` | Notify the start of an element.
    `boolean` | `usesTypeAnnotations()` | Ask whether this Outputter (or the downstream pipeline) makes any use of the type annotations supplied on element and attribute events.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.event.Receiver

      `handlesAppend`

- - ### Field Detail

    - #### pipelineConfiguration

          protected PipelineConfiguration pipelineConfiguration

    - #### systemId

          protected java.lang.String systemId

  - ### Constructor Detail

    - #### Outputter

          public Outputter()

  - ### Method Detail

    - #### setPipelineConfiguration

          public void setPipelineConfiguration​(PipelineConfiguration pipe)

      Set the pipeline configuration
      Specified by:
        `setPipelineConfiguration` in interface `Receiver`
      Parameters:
        `pipe` - the pipeline configuration

    - #### getPipelineConfiguration

          public PipelineConfiguration getPipelineConfiguration()

      Get the pipeline configuration
      Specified by:
        `getPipelineConfiguration` in interface `Receiver`
      Returns:
        the pipeline configuration

    - #### getConfiguration

          public final Configuration getConfiguration()

      Get the Saxon Configuration
      Returns:
        the configuration

    - #### setSystemId

          public void setSystemId​(java.lang.String systemId)

      Set the System ID of the tree represented by this event stream
      Specified by:
        `setSystemId` in interface `Receiver`
      Specified by:
        `setSystemId` in interface `javax.xml.transform.Result`
      Parameters:
        `systemId` - the system ID (which is used as the base URI of the nodes if there is no xml:base attribute)

    - #### getSystemId

          public java.lang.String getSystemId()

      Get the system ID
      Specified by:
        `getSystemId` in interface `javax.xml.transform.Result`
      Returns:
        the system ID that was supplied using the setSystemId() method

    - #### open

          public void open()
                    throws XPathException

      Notify the start of the event stream
      Specified by:
        `open` in interface `Receiver`
      Throws:
        `XPathException` - if an error occurs

    - #### startDocument

          public abstract void startDocument​(int properties)
                                      throws XPathException

      Notify the start of a document node
      Specified by:
        `startDocument` in interface `Receiver`
      Parameters:
        `properties` - bit-significant integer indicating properties of the document node. The definitions of the bits are in class `ReceiverOption`
      Throws:
        `XPathException` - if an error occurs

    - #### endDocument

          public abstract void endDocument()
                                    throws XPathException

      Notify the end of a document node
      Specified by:
        `endDocument` in interface `Receiver`
      Throws:
        `XPathException` - if an error occurs

    - #### setUnparsedEntity

          public void setUnparsedEntity​(java.lang.String name,
                                        java.lang.String systemID,
                                        java.lang.String publicID)
                                 throws XPathException

      Notify an unparsed entity URI.
      Specified by:
        `setUnparsedEntity` in interface `Receiver`
      Parameters:
        `name` - The name of the unparsed entity
        `systemID` - The system identifier of the unparsed entity
        `publicID` - The identifier of the unparsed entity
      Throws:
        `XPathException` - if an error occurs

    - #### startElement

          public abstract void startElement​(NodeName elemName,
                                            SchemaType typeCode,
                                            Location location,
                                            int properties)
                                     throws XPathException

      Notify the start of an element. This version of `startElement()` must be followed by calls on `attribute(NodeName, SimpleType, CharSequence, Location, int)` and `namespace(String, String, int)` to supply the attributes and namespaces; these calls may be terminated by a call on `startContent()` but this is not mandatory.
      Parameters:
        `elemName` - the name of the element.
        `typeCode` - the type annotation of the element.
        `location` - an object providing information about the module, line, and column where the node originated
        `properties` - bit-significant properties of the element node. If there are no relevant properties, zero is supplied. The definitions of the bits are in class `ReceiverOption`
      Throws:
        `XPathException` - if an error occurs

    - #### startElement

          public void startElement​(NodeName elemName,
                                   SchemaType type,
                                   AttributeMap attributes,
                                   NamespaceMap namespaces,
                                   Location location,
                                   int properties)
                            throws XPathException

      Notify the start of an element, supplying all attributes and namespaces
      Specified by:
        `startElement` in interface `Receiver`
      Parameters:
        `elemName` - the name of the element.
        `type` - the type annotation of the element.
        `attributes` - the attributes of this element
        `namespaces` - the in-scope namespaces of this element: generally this is all the in-scope namespaces, without relying on inheriting namespaces from parent elements
        `location` - an object providing information about the module, line, and column where the node originated
        `properties` - bit-significant properties of the element node. If there are no relevant properties, zero is supplied. The definitions of the bits are in class `ReceiverOption`
      Throws:
        `XPathException` - if an error occurs

    - #### namespace

          public abstract void namespace​(java.lang.String prefix,
                                         java.lang.String namespaceUri,
                                         int properties)
                                  throws XPathException

      Notify a namespace binding. This method is called at some point after startElement(). The semantics are similar to the xsl:namespace instruction in XSLT, or the namespace node constructor in XQuery. A namespace must not conflict with any namespaces already used for element or attribute names.
      Parameters:
        `prefix` - The namespace prefix; zero-length string for the default namespace
        `namespaceUri` - The namespace URI. In some cases a zero-length string may be used to indicate a namespace undeclaration.
        `properties` - The REJECT_DUPLICATES property: if set, the namespace declaration will be rejected if it conflicts with a previous declaration of the same prefix. If the property is not set, the namespace declaration will be ignored if it conflicts with a previous declaration. This reflects the fact that when copying a tree, namespaces for child elements are emitted before the namespaces of their parent element. Unfortunately this conflicts with the XSLT rule for complex content construction, where the recovery action in the event of conflicts is to take the namespace that comes last. XSLT therefore doesn't recover from this error:
      Throws:
        `XPathException` - if an error occurs
      Since:
        changed in 10.0 to report all the in-scope namespaces for an element, and to do so in a single call.

    - #### namespaces

          public void namespaces​(NamespaceBindingSet bindings,
                                 int properties)
                          throws XPathException

      Output a set of namespace bindings. This should have the same effect as outputting the namespace bindings individually using `namespace(String, String, int)`, but it may be more efficient. It is used only when copying an element node together with all its namespaces, so less checking is needed that the namespaces form a consistent and complete set
      Parameters:
        `bindings` - the set of namespace bindings
        `properties` - any special properties. The property `ReceiverOption.NAMESPACE_OK` means that no checking is needed.
      Throws:
        `XPathException` - if any failure occurs

    - #### attribute

          public abstract void attribute​(NodeName attName,
                                         SimpleType typeCode,
                                         java.lang.CharSequence value,
                                         Location location,
                                         int properties)
                                  throws XPathException

      Notify an attribute. Attributes are notified after the startElement event, and before any children. Namespaces and attributes may be intermingled.
      Parameters:
        `attName` - The name of the attribute
        `typeCode` - The type annotation of the attribute
        `value` - the string value of the attribute
        `location` - provides information such as line number and system ID.
        `properties` - Bit significant value. The following bits are defined:
        DISABLE_ESCAPING
          Disable escaping for this attribute
        NO_SPECIAL_CHARACTERS
          Attribute value contains no special characters
      Throws:
        `java.lang.IllegalStateException` - attempt to output an attribute when there is no open element start tag
        `XPathException` - if an error occurs

    - #### startContent

          public void startContent()
                            throws XPathException

      Notify the start of the content, that is, the completion of all attributes and namespaces. Note that the initial Outputter of output from XSLT instructions will not receive this event, it has to detect it itself. Note that this event is reported for every element even if it has no attributes, no namespaces, and no content.
      Throws:
        `XPathException` - if an error occurs

    - #### endElement

          public abstract void endElement()
                                   throws XPathException

      Notify the end of an element. The Outputter must maintain a stack if it needs to know which element is ending.
      Specified by:
        `endElement` in interface `Receiver`
      Throws:
        `XPathException` - if an error occurs

    - #### characters

          public abstract void characters​(java.lang.CharSequence chars,
                                          Location location,
                                          int properties)
                                   throws XPathException

      Notify character data. Note that some receivers may require the character data to be sent in a single event, but in general this is not a requirement.
      Specified by:
        `characters` in interface `Receiver`
      Parameters:
        `chars` - The characters
        `location` - provides information such as line number and system ID.
        `properties` - Bit significant value. The following bits are defined:
        DISABLE_ESCAPING
          Disable escaping for this text node
        USE_CDATA
          Output as a CDATA section
      Throws:
        `XPathException` - if an error occurs

    - #### processingInstruction

          public abstract void processingInstruction​(java.lang.String name,
                                                     java.lang.CharSequence data,
                                                     Location location,
                                                     int properties)
                                              throws XPathException

      Output a processing instruction
      Specified by:
        `processingInstruction` in interface `Receiver`
      Parameters:
        `name` - The PI name. This must be a legal name (it will not be checked).
        `data` - The data portion of the processing instruction
        `location` - provides information such as line number and system ID.
        `properties` - Additional information about the PI.
      Throws:
        `java.lang.IllegalArgumentException` - the content is invalid for an XML processing instruction
        `XPathException` - if an error occurs

    - #### comment

          public abstract void comment​(java.lang.CharSequence content,
                                       Location location,
                                       int properties)
                                throws XPathException

      Notify a comment. Comments are only notified if they are outside the DTD.
      Specified by:
        `comment` in interface `Receiver`
      Parameters:
        `content` - The content of the comment
        `location` - provides information such as line number and system ID.
        `properties` - Additional information about the comment.
      Throws:
        `java.lang.IllegalArgumentException` - the content is invalid for an XML comment
        `XPathException` - if an error occurs

    - #### append

          public void append​(Item item,
                             Location locationId,
                             int properties)
                      throws XPathException

      Append an arbitrary item (node, atomic value, or function) to the output. The default implementation throws `UnsupportedOperationException`.
      Specified by:
        `append` in interface `Receiver`
      Parameters:
        `item` - the item to be appended
        `locationId` - the location of the calling instruction, for diagnostics
        `properties` - if the item is an element node, this indicates whether its namespaces need to be copied. Values are `ReceiverOption.ALL_NAMESPACES`; the default (0) means
      Throws:
        `XPathException` - if an error occurs

    - #### append

          public void append​(Item item)
                      throws XPathException

      Append an arbitrary item (node, atomic value, or function) to the output. By default, if the item is an element node, it is copied with all namespaces. The default implementation calls `append(Item, Location, int)`, whose default implementation throws `UnsupportedOperationException`
      Specified by:
        `append` in interface `Receiver`
      Parameters:
        `item` - the item to be appended
      Throws:
        `XPathException` - if the operation fails

    - #### getStringReceiver

          public CharSequenceConsumer getStringReceiver​(boolean asTextNode,
                                                        Location loc)

      Get a string-value consumer object that allows an item of type xs:string to be appended one fragment at a time. This potentially allows operations that output large strings to avoid building the entire string in memory. The default implementation, however, simply assembles the string in a buffer and releases the entire string on completion.
      Parameters:
        `asTextNode` - set to true if the concatenated string values are to be treated as a text node
        `loc` - the location of the instruction generating the content
      Returns:
        an object that accepts xs:string values via a sequence of append() calls

    - #### close

          public void close()
                     throws XPathException

      Notify the end of the event stream
      Specified by:
        `close` in interface `Receiver`
      Throws:
        `XPathException` - if an error occurs

    - #### usesTypeAnnotations

          public boolean usesTypeAnnotations()

      Ask whether this Outputter (or the downstream pipeline) makes any use of the type annotations supplied on element and attribute events. The default implementation of this method returns false.
      Specified by:
        `usesTypeAnnotations` in interface `Receiver`
      Returns:
        true if the Outputter makes any use of this information. If false, the caller may supply untyped nodes instead of supplying the type annotation (or conversely, it may avoid stripping unwanted type annotations)